#pragma once

#include "skein/particle.h"

#include <string>
#include <map>

class ParticleMap
{
    public:
        ParticleMap() = default;
        ~ParticleMap() = default;

        // providing these as two methods keeps things unambiguous - manipulating particles
        // is just done for setup
        const Particle& getParticle(const std::string& id) const;
        glm::dvec3 getParticlePosition(const std::string& id, double time) const;
        const Orbit& getOrbit(const std::string& id) const;

        void setParticle(const Particle& particle);
        void setRelationship(const std::string& parentId, const std::string& childId, const Orbit& orbit);

    private:
        std::map<std::string, Particle> _particles;
        std::map<std::string, std::string> _relationships;
        std::map<std::string, Orbit> _orbits;
};
